// inqycomm.cpp : implementation file
//

#include "stdafx.h"
#include "inqyx.h"
#include "inqycomm.h"
#include "afxdisp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Defines for user COMMAREA lengths
#define ADDCOMMSIZE		7
#define UPDATECOMMSIZE	80
#define INQYTRAN "NEWCALL "

// Default name of the CICS Client ini file
#define INIFILENAME "\\cicscli\\bin\\cicscli.ini"
#define MAX_LINE_LEN 512

// Include for CICS ECI functions
#define CICS_W32
#include <cicseci.hpp>

// Include for subclassed ECI object to fix problem getting abend code
#include "clnterr.h"

/////////////////////////////////////////////////////////////////////////////
// inqycomm

IMPLEMENT_DYNCREATE(inqycomm, CCmdTarget)

inqycomm::inqycomm()

{
	EnableAutomation();

	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();

	// Allocate a CICS COMMAREA
	pComm = new COMMAREA;
}

inqycomm::~inqycomm()

{
	// Release our commarea storage
	delete pComm;
	
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	AfxOleUnlockApp();
}


void inqycomm::OnFinalRelease()

{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}


BEGIN_MESSAGE_MAP(inqycomm, CCmdTarget)
	//{{AFX_MSG_MAP(inqycomm)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(inqycomm, CCmdTarget)
	//{{AFX_DISPATCH_MAP(inqycomm)
	DISP_PROPERTY(inqycomm, "acctno", m_acctno, VT_BSTR)
	DISP_PROPERTY(inqycomm, "name", m_name, VT_BSTR)
	DISP_PROPERTY(inqycomm, "address", m_address, VT_BSTR)
	DISP_PROPERTY(inqycomm, "date", m_date, VT_BSTR)
	DISP_PROPERTY(inqycomm, "phone", m_phone, VT_BSTR)
	DISP_PROPERTY(inqycomm, "amount", m_amount, VT_BSTR)
	DISP_PROPERTY(inqycomm, "comment", m_comment, VT_BSTR)
	DISP_PROPERTY(inqycomm, "abcode", m_abcode, VT_BSTR)
	DISP_PROPERTY(inqycomm, "errmsg", m_errmsg, VT_BSTR)
	DISP_PROPERTY(inqycomm, "ecierrmsg", m_ecierrmsg, VT_BSTR)
	DISP_PROPERTY(inqycomm, "cicsuser", m_cicsuser, VT_BSTR)
	DISP_PROPERTY(inqycomm, "cicspw", m_cicspw, VT_BSTR)
	DISP_PROPERTY(inqycomm, "cicssys", m_cicssys, VT_BSTR)
	DISP_PROPERTY(inqycomm, "cicsclient", m_cicsclient, VT_BSTR)
	DISP_FUNCTION(inqycomm, "setCICSparms", setCICSparms, VT_EMPTY, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(inqycomm, "executeInquire", executeInquire, VT_I2, VTS_BSTR)
	DISP_FUNCTION(inqycomm, "executeUpdate", executeUpdate, VT_I2, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(inqycomm, "executeAdd", executeAdd, VT_I2, VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(inqycomm, "getErrmsg", getErrmsg, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(inqycomm, "getECIerr", getECIerr, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(inqycomm, "getAbcode", getAbcode, VT_BSTR, VTS_NONE)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_Iinqycomm to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {CDF82D51-B808-11D1-BBB0-08005AA55FA5}
static const IID IID_Iinqycomm =
{ 0xcdf82d51, 0xb808, 0x11d1, { 0xbb, 0xb0, 0x8, 0x0, 0x5a, 0xa5, 0x5f, 0xa5 } };

BEGIN_INTERFACE_MAP(inqycomm, CCmdTarget)
	INTERFACE_PART(inqycomm, IID_Iinqycomm, Dispatch)
END_INTERFACE_MAP()

// {CDF82D53-B808-11D1-BBB0-08005AA55FA5}
IMPLEMENT_OLECREATE(inqycomm, "inqyx.inqycomm", 0xcdf82d53, 0xb808, 0x11d1, 0xbb, 0xb0, 0x8, 0x0, 0x5a, 0xa5, 0x5f, 0xa5)

/////////////////////////////////////////////////////////////////////////////
// inqycomm message handlers

void inqycomm::setCICSparms(LPCTSTR userid, LPCTSTR password, LPCTSTR system, LPCTSTR client) 
{
	// TODO: Add your dispatch handler code here
	m_cicsuser   = userid;
	m_cicspw     = password;
	m_cicssys    = system;
	m_cicsclient = client;
}

short inqycomm::executeInquire(LPCTSTR acctno) 
{
	// TODO: Add your dispatch handler code here
	// get the account number into the instance variable
	m_acctno = acctno;

	// Fill in the COMMAREA
	setMenuMapData(pComm);

	//Execute the CICS ECI call

	// set the transaction code 
	// note that we will use the update code, so that we get back
	// a user comm area with the current record status. This allows
	// the user to change the data and then press the update button.
	memcpy(pComm->inqy.comm_head.USRTRNID,"UPDT",4);

	// set the user COMMAREA length to zero
	memset(pComm->inqy.comm_head.USRCALEN, '0',
           sizeof(pComm->inqy.comm_head.USRCALEN));

	// Execute the CICS Transaction and update the instance variables
	int rc = executeCICSTran(INQYTRAN);

	return rc;
}

short inqycomm::executeUpdate(LPCTSTR acctno, LPCTSTR name, LPCTSTR address, LPCTSTR idate, LPCTSTR phone, LPCTSTR amount, LPCTSTR comment) 
{
	// TODO: Add your dispatch handler code here
	// Get the input into the instance variables
	m_acctno  = acctno;
	m_name    = name;
	m_address = address;
	m_date    = idate;
	m_phone   = phone;
	m_amount  = amount;
	m_comment = comment;

	// set the user input data                   
	// the user program expects binary zeros     
	// in any unmodified fields.  Since the      
	// commarea was initialized to binary zeros  
	// no action is necessary on unmodified      
	// fields.  Fields will be compared to their 
	// original values to see if they have been  
	// changed.                                  
	// To update a record requires two user      
	// interactions.  In the first one, the user 
	// enters the account number and selects     
	// update.  The account information is       
	// displayed, and the oldaccount field is    
	// set as a hidden variable in the HTML      
	// page.  The user then changes the data and 
	// selects update again.  This time, the     
	// fields which have been changed are        
	// updated in the file.  The first decision  
	// is to determine whether this is the first 
	// interaction for this account number or    
	// second.                                   

	// Check if we are updating an account that has already been displayed
	// If the accounts match, then proceed with the update, otherwise
	// display the data for the new account number, as an inquiry
	if (m_acctno.Compare(old_account) == 0)
	{
		// second interaction, try to update the  
		// account data.                          
		setDetailMapData(pComm);

     
		// set the user commarea length 
		// for updates, the host program expects 80 bytes 
		CInqyxApp::int2char(UPDATECOMMSIZE, pComm->inqy.comm_head.USRCALEN,
							sizeof(pComm->inqy.comm_head.USRCALEN));

		// set the user commarea data
		loadUserComm(pComm);
	}
	else
	{
		// first interaction, display the account 
		// information for the user to change.    
		// move the account number to the keyi field 
		setMenuMapData(pComm);

		// set the user commarea length to indicate 
		//the first pass.                          
		memset(pComm->inqy.comm_head.USRCALEN, '0',
				sizeof(pComm->inqy.comm_head.USRCALEN));
	}

	// set the transaction code 
	memcpy(pComm->inqy.comm_head.USRTRNID,"UPDT",4);

	// End of COMMAREA build

	// Execute the CICS Transaction and update the instance variables
	int rc = executeCICSTran(INQYTRAN);

	return rc;
}

short inqycomm::executeAdd(LPCTSTR acctno, LPCTSTR name, LPCTSTR address, LPCTSTR idate, LPCTSTR phone, LPCTSTR amount, LPCTSTR comment) 
{
	// TODO: Add your dispatch handler code here
	// Get the input into the instance variables
	m_acctno  = acctno;
	m_name    = name;
	m_address = address;
	m_date    = idate;
	m_phone   = phone;
	m_amount  = amount;
	m_comment = comment;

	// Set the input fields in the COMMAREA
	setDetailMapData(pComm);

	// set the transaction code 
	memcpy(pComm->inqy.comm_head.USRTRNID,"ADDS",4);

	// set the user commarea length 
	CInqyxApp::int2char(ADDCOMMSIZE, pComm->inqy.comm_head.USRCALEN,
						sizeof(pComm->inqy.comm_head.USRCALEN));

	// set the account number in the user commarea 
	CInqyxApp::move_comm(m_acctno, pComm->inqy.user_comm.NUMB,
						 sizeof(pComm->inqy.user_comm.NUMB),
						 NUMERIC_FIELD);

	// End of COMMAREA build

	// Execute the CICS Transaction and update the instance variables
	int rc = executeCICSTran(INQYTRAN);

	return rc;
}

BSTR inqycomm::getErrmsg() 
{
	// TODO: Add your dispatch handler code here

	return m_errmsg.AllocSysString();
}

BSTR inqycomm::getECIerr() 
{
	// TODO: Add your dispatch handler code here

	return m_ecierrmsg.AllocSysString();
}

BSTR inqycomm::getAbcode() 

{
	// TODO: Add your dispatch handler code here

	return m_abcode.AllocSysString();
}

void inqycomm::loadUserComm(PCOMMAREA pComm)

{
	// This routine loads the user COMMAREA for updates
	// It is expected to contain an image of the record
	// before the update
    pComm->inqy.user_comm.STAT = old_stat; // Record Status byte
	CInqyxApp::move_comm(old_account, pComm->inqy.user_comm.NUMB,
						 sizeof(pComm->inqy.user_comm.NUMB),NUMERIC_FIELD);
	CInqyxApp::move_comm(old_name, pComm->inqy.user_comm.NAMEX, 
						 sizeof(pComm->inqy.user_comm.NAMEX),ALPHA_FIELD);
    CInqyxApp::move_comm(old_addr, pComm->inqy.user_comm.ADDRX, 
						 sizeof(pComm->inqy.user_comm.ADDRX),ALPHA_FIELD);
    CInqyxApp::move_comm(old_phone, pComm->inqy.user_comm.PHONE, 
						 sizeof(pComm->inqy.user_comm.PHONE),ALPHA_FIELD);
    CInqyxApp::move_comm(old_date, pComm->inqy.user_comm.DATEX, 
						 sizeof(pComm->inqy.user_comm.DATEX),ALPHA_FIELD);
    CInqyxApp::move_comm(old_amount, pComm->inqy.user_comm.AMOUNT, 
						 sizeof(pComm->inqy.user_comm.AMOUNT),ALPHA_FIELD);
    CInqyxApp::move_comm(old_comments, pComm->inqy.user_comm.COMMENT, 
						 sizeof(pComm->inqy.user_comm.COMMENT),ALPHA_FIELD);
}

void inqycomm::setDetailMapData(PCOMMAREA pComm)

{
	// Total length of all input data in map
	short maplen = 0;

	// Clear the data area to nulls
	memset(pComm, '\0', sizeof(COMMAREA));

	// Set the Client Name field in the COMMAREA
	CInqyxApp::move_comm(m_cicsclient, pComm->brws.comm_head.USRTRMID, 
						 sizeof(pComm->brws.comm_head.USRTRMID), ALPHA_FIELD);

	// Set the BMS fields
	CInqyxApp::moveBMSfield(m_acctno,
							pComm->inqy.detail.dfhdgbi.numbi,
							&pComm->inqy.detail.dfhdgbi.numbl,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.numbi),
							NUMERIC_FIELD);

	CInqyxApp::moveBMSfield(m_name,
							pComm->inqy.detail.dfhdgbi.namei,
							&pComm->inqy.detail.dfhdgbi.namel,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.namei),
							ALPHA_FIELD);

	CInqyxApp::moveBMSfield(m_address,
							pComm->inqy.detail.dfhdgbi.addri,
							&pComm->inqy.detail.dfhdgbi.addrl,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.addri),
							ALPHA_FIELD);

	CInqyxApp::moveBMSfield(m_phone,
							pComm->inqy.detail.dfhdgbi.phonei,
							&pComm->inqy.detail.dfhdgbi.phonel,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.phonei),
							ALPHA_FIELD);

	CInqyxApp::moveBMSfield(m_date,
							pComm->inqy.detail.dfhdgbi.datei,
							&pComm->inqy.detail.dfhdgbi.datel,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.datei),
							ALPHA_FIELD);

	CInqyxApp::moveBMSfield(m_amount,
							pComm->inqy.detail.dfhdgbi.amounti,
							&pComm->inqy.detail.dfhdgbi.amountl,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.amounti),
							ALPHA_FIELD);

	CInqyxApp::moveBMSfield(m_comment,
							pComm->inqy.detail.dfhdgbi.commenti,
							&pComm->inqy.detail.dfhdgbi.commentl,
							&maplen,
							sizeof(pComm->inqy.detail.dfhdgbi.commenti),
							ALPHA_FIELD);

	CInqyxApp::int2char(maplen, pComm->inqy.comm_head.USRMAPLN,
						sizeof(pComm->inqy.comm_head.USRMAPLN));

	// set the version number to zero
	memset(pComm->brws.comm_head.VERSION, '0',
			sizeof(pComm->brws.comm_head.VERSION));

	// set the map name 
	memcpy(pComm->inqy.comm_head.MAPNAME,"DETAIL  ",8);
}

void inqycomm::setMenuMapData(PCOMMAREA pComm)
{
	// Total length of all input data in map
	short maplen = 0;

	// Clear the data area to nulls
	memset(pComm, '\0', sizeof(COMMAREA));

	// Set the Client Name field in the COMMAREA
	CInqyxApp::move_comm(m_cicsclient, pComm->brws.comm_head.USRTRMID, 
						 sizeof(pComm->brws.comm_head.USRTRMID), ALPHA_FIELD);

	// set the account number from the instance variable
	CInqyxApp::moveBMSfield(m_acctno,
							pComm->inqy.menu.dfhdgai.keyi,
							&pComm->inqy.menu.dfhdgai.keyl,
							&maplen,
							sizeof(pComm->inqy.menu.dfhdgai.keyi),
							NUMERIC_FIELD);

	// set the version number to zero
	memset(pComm->brws.comm_head.VERSION, '0',
			sizeof(pComm->brws.comm_head.VERSION));

	// set the map name
	memcpy(pComm->inqy.comm_head.MAPNAME,"MENU    ",8);
}

int inqycomm::executeCICSTran(char* tran)

{
	int RC = 0;

	// The ECI object is assumed to have been built in the logon dll
	// If not, then the following comment should be removed and
	// the line after that removed.  The use of the ECI object
	// below to get the abend code must be changed from a pointer
	// reference (->) to a member reference (.)
	//fixCclECI inqyECI;
	fixCclECI* inqyECI = (fixCclECI*) CclECI::instance();

	// Build comm, buffer and a flow objects
	CclBuf buffer(sizeof(COMMAREA),pComm);
	CclFlow sflow(Ccl::sync);
	CclConn connection(m_cicssys, m_cicsuser, m_cicspw);

	// Clear the previous CICS error message text
	m_ecierrmsg.Empty();
	m_abcode.Empty();
	m_errmsg.Empty();

	try {	// Catch block for CclClass exceptions
			connection.link(sflow, tran, &buffer);
            getDataFromComm(pComm);
	    }    // Catch CclClass exceptions
	catch ( CclException& exception ) 
		{
			RC = exception.exCode();
			m_ecierrmsg = exception.exCodeText();
			m_abcode = inqyECI->m_Cclabcode;
			// Now, be realy daring and try to throw an exception back
			// through OLE to the Visual Basic program
			// the following lines are commented out
			// They will pass the exception back to the visual basic
			// program.  This requires the VB program to have an
			// ON ERROR statement active to catch the exception.
			// If this support is desired, then remove the comments 
			// and recompile the DLL
//			COleDispatchException* pException = new COleDispatchException(
//				m_ecierrmsg, 200, RC);
//			pException->m_scError = 0;
			// Throw the exception back to VB
//			throw(pException);
        } // end catch

	return RC;
}

void inqycomm::getDataFromComm(PCOMMAREA pComm)
{
	// Reset the old data values
	resetOldValues();

	// Check for a DETAIL map
	if (memcmp(pComm->inqy.comm_head.MAPNAME,"DETAIL  ",
               sizeof(pComm->inqy.comm_head.MAPNAME)) == 0)
	{
		// Populate the dialog field variables
		CInqyxApp::comm_move(m_name, pComm->inqy.detail.dfhdgbi.namei,
							 sizeof(pComm->inqy.detail.dfhdgbi.namei));

		CInqyxApp::comm_move(m_address, pComm->inqy.detail.dfhdgbi.addri,
							 sizeof(pComm->inqy.detail.dfhdgbi.addri));

		CInqyxApp::comm_move(m_phone, pComm->inqy.detail.dfhdgbi.phonei,
							 sizeof(pComm->inqy.detail.dfhdgbi.phonei));

		CInqyxApp::comm_move(m_date, pComm->inqy.detail.dfhdgbi.datei,
							 sizeof(pComm->inqy.detail.dfhdgbi.datei));

		CInqyxApp::comm_move(m_amount, pComm->inqy.detail.dfhdgbi.amounti,
							 sizeof(pComm->inqy.detail.dfhdgbi.amounti));

		CInqyxApp::comm_move(m_comment, pComm->inqy.detail.dfhdgbi.commenti,
							 sizeof(pComm->inqy.detail.dfhdgbi.commenti));

		// remember the initial values in case of an update
		// the application requires the original values in the user COMMAREA
		setOldValues(pComm);

		if ((pComm->inqy.detail.dfhdgbo.msg1o[0] != '\0') &&
			(pComm->inqy.detail.dfhdgbo.msg1o[0] != ' '))
		{
			CInqyxApp::comm_move(m_errmsg, pComm->inqy.detail.dfhdgbo.msg1o,
								 sizeof(pComm->inqy.detail.dfhdgbo.msg1o));
		}

		if ((pComm->inqy.detail.dfhdgbo.msg3o[0] != '\0') &&
			(pComm->inqy.detail.dfhdgbo.msg3o[0] != ' '))
		{
			CInqyxApp::comm_move(m_errmsg, pComm->inqy.detail.dfhdgbo.msg3o,
								 sizeof(pComm->inqy.detail.dfhdgbo.msg3o));
		}
	}

	// Check for a MENU map
	if (memcmp(pComm->inqy.comm_head.MAPNAME,"MENU    ",
			   sizeof(pComm->inqy.comm_head.MAPNAME)) == 0)
	{
		CInqyxApp::comm_move(m_errmsg, pComm->inqy.menu.dfhdgao.msgo,
							 sizeof(pComm->inqy.menu.dfhdgao.msgo));
	}

	// Check for a CICS SEND TEXT
	if (memcmp(pComm->inqy.comm_head.MAPNAME,"SENDTEXT",
			   sizeof(pComm->inqy.comm_head.MAPNAME)) == 0)
	{
		CInqyxApp::comm_move(m_errmsg, pComm->inqy.comm_head.textarea,
							 sizeof(pComm->inqy.comm_head.textarea));
	} // endif

}

void inqycomm::setOldValues(PCOMMAREA pComm)

{
	old_stat     = pComm->inqy.user_comm.STAT;
	old_account  = m_acctno;
	old_addr     = m_address;
	old_comments = m_comment;
	old_date     = m_date;
	old_name     = m_name;
	old_phone    = m_phone;
	old_amount   = m_amount;
}

void inqycomm::resetOldValues()

{
	old_stat     = 0;
	old_account  = _T("");
	old_addr     = _T("");
	old_comments = _T("");
	old_date     = _T("");
	old_name     = _T("");
	old_phone    = _T("");
	old_amount   = _T("");
}

//***********************************************
//  End of file
//***********************************************
