// inqyx.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "inqyx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CInqyxApp

BEGIN_MESSAGE_MAP(CInqyxApp, CWinApp)
	//{{AFX_MSG_MAP(CInqyxApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInqyxApp construction

CInqyxApp::CInqyxApp()
{
	TRACE("inqyx Constructor\n");
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CInqyxApp object

CInqyxApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CInqyxApp initialization

BOOL CInqyxApp::InitInstance()
{
	TRACE("inqyx::InitInstance\n");
	// Register all OLE server (factories) as running.  This enables the
	//  OLE libraries to create objects from other applications.
	COleObjectFactory::RegisterAll();

	return TRUE;
}

////////////////////////////////////////////////////////////////
// Routine to save an integer as a number string              
////////////////////////////////////////////////////////////////

void CInqyxApp::int2char(const int i, char *result, const int len)

{
   char temp[18];
   int maxlen;

   itoa(i, temp, 10);

   if (len < 12)
   {
      maxlen = len;
   }
   else
   {
      maxlen = 11;
   } /* endif */

   if (maxlen > 0)
   {
      memset(result, '0', maxlen);
      if (strlen(temp) > 0)
      {
         memcpy(result + maxlen - strlen(temp), temp, strlen(temp));
      } /* endif */
   } /* endif */
}

////////////////////////////////////////////////////////////////
// Routine to get the value of a variable (CString) and then  
//  copy it into the CICS commarea.                           
////////////////////////////////////////////////////////////////

void CInqyxApp::move_comm(CString& VarData,
               char   *CommField,
               int    maxLen,
               int    isNumber)

{
    int     len;
    LPCSTR  userdata;

    /* Get the length of the CString data */
    len = VarData.GetLength();

    /* Get a pointer to the CString data */
    userdata = VarData;

    if (len > maxLen)
     {
       len = maxLen;
     }

    /* set the field to blanks or zeros */
    if (isNumber == NUMERIC_FIELD)
    {
       /* numeric field - initialize to zeros */
       memset(CommField,'0',maxLen);

       /* copy the data, if there is any, right justified */
       if (len > 0)
       {
          memcpy(CommField + maxLen - len, userdata, len);
       }
    }
    else
    {
       /* alpha field - initialize to blanks */
       if (isNumber == ALPHA_FIELD)
       {
          memset(CommField,' ',maxLen);
       }
       else
       {
          memset(CommField,'\0',maxLen);
       }

       /* copy the data, if there is any, left justified */
       if (len > 0)
       {
          memcpy(CommField, userdata, len);
       }
    }

	/* Release the Buffer Pointer */
	VarData.ReleaseBuffer();
}

////////////////////////////////////////////////////////////////
// Routine to take data out of the CICS commarea and turn     
//  it into a valid CString, stripping trailing blanks.       
////////////////////////////////////////////////////////////////

void CInqyxApp::comm_move(CString& VarData, char *commarea, long Varlen)

{
   int  len;
   char temp[4096];

   /* Erase the current contents of the CString variable */
   VarData.Empty();

   /* Make sure we don't overflow our work variable */
   len = Varlen;
   if (len > 4096)
   {
      len = 4096;
   } /* endif */

   /* Get the data into a work variable */
   memcpy(temp, commarea, Varlen);
   temp[len] = 0;

   /* strip trailing blanks */
   len--;
   while (temp[len] == ' ')
    {
      temp[len] = '\0';
      len--;

      if (len < 0)
         break;
    } /* endwhile */

   VarData = temp;
}

////////////////////////////////////////////////////////////////
// Routine to move data into a CICS BMS map field.  This
//  routine moves the data into the data portion of the
//  BMS field and sets the BMS field length with the length
//  of the data item.  It also keeps track of the total
//  length of all the data.
////////////////////////////////////////////////////////////////

void CInqyxApp::moveBMSfield(CString&  Vardata,    // Variable data from GUI
                  char      *BMSfield,  // BMS Map Data Area
                  short     *BMSlen,    // BMS Map Length field
                  short     *MAPlen,    // Total Map Data length
                  int       maxLen,     // Length of Data Area
                  int       isNumber)   // Data Type

{
   int    len;

   move_comm(Vardata, BMSfield, maxLen, isNumber);

   /* get the length of the new data */
   len = strlen(Vardata);

   /* make sure it is not too long */
   if (len > maxLen)
   {
      len = maxLen;
   }

   /* set the BMS map length field */
   *BMSlen = len;

   /* set the total BMS bytes in map field                   */
   *MAPlen += len;
}

/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	TRACE("Entering DllGetClassObject\n");
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	TRACE("Returning from DllGetClassObject\n");
	return AfxDllGetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return AfxDllCanUnloadNow();
}

// by exporting DllRegisterServer, you can use regsvr.exe
STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	COleObjectFactory::UpdateRegistryAll();
	return S_OK;
}

// by exporting DllUnregisterServer, you can use regsvr.exe
STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	COleObjectFactory::RevokeAll();
	return S_OK;
}

